package com.crm.globex.dao.repository;

import com.crm.rely.backend.dao.repository.BaseRepository;
import com.crm.rely.backend.model.pojo.table.CustomLoginAssetManagementTable;
import com.crm.rely.backend.model.pojo.table.CustomLoginDemoTable;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;
import java.util.Date;

/**
 * @author: houn
 */
@Repository
public interface CustomLoginDemoRepository extends BaseRepository<CustomLoginDemoTable> {

    boolean existsByLogin(Long login);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CustomLoginDemoTable findFirstByLogin(Long login);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CustomLoginDemoTable findFirstByLoginStatus(Integer loginStatus);

    CustomLoginDemoTable getFirstByCustomIdAndLogin(Long customId, Long login);

    boolean existsByCustomIdAndLogin(Long customId, Long login);
    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CustomLoginDemoTable findFirstByLoginStatusAndValidAndExpirationTimeLessThanAndExpirationTimeIsNotNull(Integer loginStatus, Integer valid, Date time);

}
